import 'package:bird/bird.dart';
// ignore_for_file: type_annotate_public_apis

class MyTestBloc extends HookBloc {
  final Sea<MyModel> model = const MyModel(1, MyModel2("Tim", "That's me")).$;

  MyTestBloc();
}

void main() {
  final bloc = MyTestBloc();

  final _a = bloc
      .model
      .seaThen(myModelBLens)
      .seaThen(myModel2NameLens)
      .seaThenRM(myModel2LowercaseOnlyNameLens)
  ;

  final a = _a.sourceSea.subscribe((n) => print("NewModel: $n"));

  _a.put("ba");
  _a.put("BA");
  _a.put("Ba");
  _a.put("ba2");
  _a.put("BA2");
  _a.put("bA2");

  a.cancel();
}

class MyModel {
  final int a;
  final MyModel2 b;

  const MyModel(this.a, this.b);

  @override
  String toString() => 'MyModel{a: $a, b: $b}';
}

class MyModel2 {
  final String name;
  final String description;

  const MyModel2(this.name, this.description);

  @override
  String toString() {
    return 'MyModel2{name: $name, description: $description}';
  }
}

final myModelBLens = lens.s<MyModel, MyModel2>(
      (a) => a.b,
      (a, b) => MyModel(a.a, b),
);

final myModel2NameLens = lens.s<MyModel2, String>(
      (a) => a.name,
      (a, b) => MyModel2(a.name, b),
);

final myModel2LowercaseOnlyNameLens = lens.rm<String, String, ForOption>(
  id,
      (a, b) => (b.toLowerCase() == b) ? some(b) : none<String>(),
);
