import 'package:bird/fp.dart';
// ignore_for_file: type_annotate_public_apis

void main() {
  const model = MyModel(Names("John", "Doe"), 21);

  var a = model;

  final aPropLens = lens.prop(() => model, (MyModel b) => a = b);

  final aa = aPropLens.p(MyModel$.age);

  print(a);
  aa.propSet(const Id(19));
  print(a);

  final optionIntLens = lens.m(
        (int a) => a == 16 ? none<int>() : some(a * 2),
        (int a, int b) => b == 10 ? none<int>() : some(a + b),
  );

  final intLens = lens.s(
        (int a) => a == 16 ? 10 : a * 2,
        (int a, int b) => b == 10 ? 11 : a + b,
  );

  optionIntLens.then(optionIntLens);
  intLens.then(intLens);
}

class MyModel$ {
  static final name = lens.id<MyModel, Names>(
        (a) => a.name,
        (a, b) => MyModel(b, a.age),
  );

  static final age = lens.id<MyModel, int>(
        (a) => a.age,
        (a, b) => MyModel(a.name, b),
  );
}

class MyModel {
  final Names name;
  final int age;

  const MyModel(this.name, this.age);

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is MyModel &&
              runtimeType == other.runtimeType &&
              name == other.name &&
              age == other.age;

  @override
  int get hashCode =>
      name.hashCode ^
      age.hashCode;

  @override
  String toString() {
    return 'MyModel{name: $name, age: $age}';
  }
}

class Names$ {
  static final firstName = lens.id<Names, String>(
        (a) => a.firstName,
        (a, b) => Names(b, a.secondName),
  );
  static final secondName = lens.id<Names, String>(
        (a) => a.secondName,
        (a, b) => Names(a.firstName, b),
  );
}

class Names {
  final String firstName;
  final String secondName;

  const Names(this.firstName, this.secondName);

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is Names &&
              runtimeType == other.runtimeType &&
              firstName == other.firstName &&
              secondName == other.secondName;

  @override
  int get hashCode =>
      firstName.hashCode ^
      secondName.hashCode;

  @override
  String toString() {
    return 'Names{firstName: $firstName, secondName: $secondName}';
  }
}
