import 'package:bird/fp.dart';

abstract class Functor<F, A> {
  Kind<F, C> map<C>(C Function(A) f);
}

abstract class Applicative<F, A> implements Functor<F, A> {
  Kind<F, A> pure(A a);

  Kind<F, C> ap<C>(Kind<F, C Function(A)> f);
}

abstract class Monad<F, A> implements Applicative<F, A> {
  Kind<F, C> bind<C>(Kind<F, C> Function(A) f);
}

