import 'package:bird/fp.dart';

extension KindIDMonadFix<A> on Kind<ForId, A> {
  Id<A> get D => this as Id<A>;
}

class ForId<A> implements Kind<ForId, A>, Monad<ForId, A> {
  @override
  Kind<ForId, C> ap<C>(Kind<ForId, C Function(A)> f) => KindIDMonadFix(this).D.ap(f);

  @override
  Kind<ForId, C> bind<C>(Kind<ForId, C> Function(A) f) => KindIDMonadFix(this).D.bind(f);

  @override
  Kind<ForId, C> map<C>(C Function(A) f) => KindIDMonadFix(this).D.map(f);

  @override
  Kind<ForId, A> pure(A a) => KindIDMonadFix(this).D.pure(a);
}

class Id<A> implements Kind<ForId, A>, Monad<ForId, A> {
  final A value;

  const Id(this.value);

  @override
  Kind<ForId, C> ap<C>(Kind<ForId, C Function(A)> f) =>
      bind((a) => KindIDMonadFix(f).D.map((b) => b(a)));

  @override
  Kind<ForId, C> bind<C>(Kind<ForId, C> Function(A) f) => f(value);

  @override
  Kind<ForId, C> map<C>(C Function(A) f) => Id(f(value));

  @override
  Kind<ForId, A> pure(A a) => Id(a);
}
