import 'package:bird/fp.dart';
// ignore_for_file: void_checks

extension PropLensX<GIn> on
Glass<void, Kind<ForId, GIn>, void, Kind<ForId, GIn>, void> {
  void propSet(Kind<ForId, GIn> a) => set(get(Null), a);

  Glass<void, Kind<ForId, GOut>, void, Kind<ForId, GOut>, void> p<GOut>(
      Glass<Kind<ForId, GIn>,
          Kind<ForId, GOut>,
          Kind<ForId, GIn>,
          Kind<ForId, GOut>,
          Kind<ForId, GIn>> l) {
    return ConcreteGlass(
          (void a) => l.get(get(Null)),
          (void a, b) => set(Null, l.set(get(Null), b)),
    );
  }
}

extension PropUpdate<GIn, GOut, SIn, SOut> on
Glass<GIn, GOut, void, SIn, void> {
  void put(SIn val) => set(Null, val);
}

extension LensExtension<S, T> on Glass<S, T, S, T, S> {
  Glass<S, A, S, A, S> then<A>(Glass<T, A, T, A, T> other) {
    return lens.s(
          (S a) => other.get(get(a)),
          (S s, A a) => set(s, other.set(get(s), a)),
    );
  }

  Glass<S, A, S, A, Kind<F, S>> thenRM<A, F extends Monad<F, dynamic>>(
      Glass<T, A, T, A, Kind<F, T>> other) {
    return lens.rm(
          (S a) => other.get(get(a)),
          (S s, A a) {
        return (other.set(get(s), a) as Monad<F, T>)
            .map((val) => set(s, val));
      },
    );
  }
}
extension MonadLensExtension<S, T, F extends Monad<F, dynamic>> on
Glass<S, Kind<F, T>, S, T, Kind<F, S>> {
  Glass<S, Kind<F, A>, S, A, Kind<F, S>> then<A>(
      Glass<T, Kind<F, A>, T, A, Kind<F, T>> other) {
    return lens.m((S a) {
      return (get(a) as Monad<F, T>).bind<A>(other.get);
    }, (S s, A a) {
      return (get(s) as Monad<F, T>).bind<S>((T _t) {
        return (other.set(_t, a) as Monad<F, T>).bind<S>((T t) {
          return set(s, t);
        });
      });
    });
  }
}

extension LensIDExtension<GIn, GOut, C, SIn, SOut> on
Glass<GIn, GOut, C, SIn, SOut> {
  Glass<GIn, Kind<ForId, GOut>, C, SIn, Kind<ForId, SOut>> get oToId =>
      ConcreteGlass((a) => Id(get(a)), (a, b) => Id(set(a, b)));

  Glass<Kind<ForId, GIn>,
      GOut,
      Kind<ForId, C>,
      SIn,
      Kind<ForId, SOut>> get iToId =>
      ConcreteGlass((a) => get(a.D.value), (a, b) =>
          Id(set(a.D.value, b)));

  Glass<Kind<ForId, GIn>,
      Kind<ForId, GOut>,
      Kind<ForId, C>,
      Kind<ForId, SIn>,
      Kind<ForId, SOut>> get toId =>
      ConcreteGlass(
            (a) => a.D.map(get),
            (a, b) => a.D.bind((a) => b.D.map((b) => set(a, b))),
      );
}

extension MonadLensSetExtension<S, T, F extends Monad<F, dynamic>> on
Glass<S, T, S, T, Kind<F, S>> {
  Glass<S, A, S, A, Kind<F, S>> thenRM<A, G extends Monad<G, dynamic>>(
      Glass<T, A, T, A, Kind<F, T>> other) {
    return lens.rm((S a) {
      return other.get(get(a));
    }, (S s, A a) {
      return (get(s) as Monad<F, T>).bind<S>((T _t) {
        return (other.set(_t, a) as Monad<F, T>).bind<S>((T t) {
          return set(s, t);
        });
      });
    });
  }
}
