import 'package:bird/fp.dart';

class List$ {
  const List$._();

  static Glass<List<T>, T, List<T>, T, List<T>> atIndex<T>(int i) =>
      lens.s<List<T>, T>(
        (s) => s[i],
        (a, b) {
          assert(i >= 0 && i < a.length);
          final newS = List<T>.from(a);
          newS.replaceRange(i, i + 1, [b]);
          return newS;
        },
      );

  static Glass<List<T>, T, List<T>, T, List<T>> first<T>() => atIndex(0);

  static Glass<List<T>, T, List<T>, T, List<T>> where<T>(bool Function(T) predicate) =>
      lens.s<List<T>, T>(
        (s) => s.firstWhere(predicate),
        (a, b) {
          final index = a.indexWhere(predicate);
          final newS = List<T>.from(a);
          newS.replaceRange(index, index + 1, [b]);
          return newS;
        },
      );

  static Glass<List<T>, Option<T>, List<T>, Option<T>, List<T>> whereOptional<T>(
      bool Function(T) predicate) =>
      lens.s(
        (s) => optionOf(s.firstWhere(predicate, orElse: () => null)),
        (a, b) {
          return b.fold(
                  () => a, (val) {
            final index = a.indexWhere(predicate);
            if (index < 0) return a;
            final newS = List<T>.from(a);
            newS.replaceRange(index, index + 1, [val]);
            return newS;
          });
        },
      );
}

