import 'package:bird/fp.dart';
import 'package:test/test.dart';

void main() {
  group("Option", () {
    test("fold", () {
      final a = some(2).fold(() => throw Exception(""), (a) => a);
      expect(a, 2);
      final b = none<int>().fold(() => 0, (_) => throw Exception());
      expect(b, 0);
    });
    test("forEach", () {
      int a;
      some(2).forEach((f) => a = f);
      expect(a, 2);
      int b;
      none<int>().forEach((f) => b = f);
      expect(b, null);
    });
    test("toString", () {
      expect(some(2).toString(), "Some(${2})");
      expect(none<int>().toString(), "None");
    });
    group("monad", () {
      test("map", () {
        expect(some(2).map((a) => a * 3), some(6));
        expect(none<int>().map((a) => a * 3), none<int>());
      });
      test("bind", () {
        expect(some(2).bind((i) => some(2 * 3)), some(6));
        expect(none<int>().bind((i) => some(2 * 3)), none<int>());
      });
      test("ap", () {
        expect(some(2).ap(some((i) => i * 3)), some(6));
        expect(none<int>().ap(some((i) => i * 2)), none<int>());
        expect(some(2).ap<int>(none((int i) => i * 3)), none<int>());
        expect(none<int>().ap<int>(none((int i) => i * 2)), none<int>());
      });
      test("pure", () {
        expect(some(4).pure(10), some(10));
        expect(none<int>().pure(10), some(10));
      });
      // laws
      // ...
    });
  });
}
